/**************************************
 *   C _ U R A V         2 . 0        *
 *        *
 *               *
 *    -                  *
 *                                    * 
 *                   *
 *                                    *
 *   (C) 2002-2005 ᪮ ᥩ     *
 *   ᪨ 䠪             *
 **************************************/
/*       :
	ࠢ   ⢥ 
	[Cu(NH3)4]SO4*H2O=CuO+SO3+NH3+H2O
	CaSO4*0.5H2O+H2O=CaSO4*2H2O
	Cr2O7{2-}+H{+}+e=Cr{3+}+H2O
	Fe{3+}+e=Fe  ..
	 砥 ⠭  த⠬ ॠ樨  室묨 -
	(ਬ, H2O  ), ணࠬ ࠭ 訡.

	:
	1. 㫠  ⢠  ᮤঠ 
	      ()  []     *
	2.   ॠ樨  ࠢ   ⮩ ணࠬ
	    2NO2 + O3 = N2O5 + O2
	3. ࠢ   ᮤঠ  20 ⮢
	   / 
	4. ⨬ ᯮ짮 ᪮쪨 +  -  拉:
	   Sn{++} SO4{--}  . . */

/***   ***/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "gauss2.inc"

/**********  **********/
#define ACCURACY GAUSS_ACCURACY
#define ERR_MANYSOL "  ࠢ ᪮ ᫮ ᯮᮡ"
#define ERR_NOSOL " ॠ  ࠢ"
#define ERR_EQU "୮ ᯮ짮 '='"
#define ERR_PLUS "୮ ᯮ짮 '+'"
#define ERR_SYNT "⠪᪠ 訡"
#define ERR_WRONGEL " %c%c    ࠢ"
#define ERR_CHARGE "襭  ࠭ 鸞"
#define ERR_MANYELEM "誮  ⮢"
#define ERR_MANYCOMP "誮  ᮥ"
#define ERR_MANYBR "誮  ᪮"
#define ERR_SYNTBR "ࠢ쭮 ᯮ짮 ᪮"

/**********   **********/
double rou(double x);
char cmpzero(double x);

/**********  **********/
struct composition /*   ࠭  ⢠ */
{
	char name[64];   /*  ᮥ */
	int charge;      /*   */
};

struct brackets /*   ࠭ न ᪮ */
{
	unsigned char open_sign; /*  ⮩ ᪮ */
	unsigned char close_sign; /*  ⮩ ᪮ */
	int open_pos;        /*  뢠饩 ᪮ */
	int close_pos;       /*  뢠饩 ᪮ */
	double index;        /*   ᪮ */
};

/**********   **********/
/*   㭪 ⢫ ࠢ
    ࠢ ॠ樨. ଠ  㪠
     砫 ⮣ ⨭.

    char *in  - 室 ப
    char *res - 室 ப

    㭪 頥 0  砥 ᯥ
                      1  砥 訡 

     室 ப ᠭ  ࠢ
    ࠢ,  ⥪⮢ ᮮ饭 
    ᠭ 訡 */

/***   㭪樨 c_urav ***/
/* 뢮   ப */
#define PRINT(fmt, arg) {sprintf(buf, fmt, arg); \
                         strcat(res, buf);}

#define LPRINT(arg) {sprintf(buf, arg);\
                     strcat(res, buf);}

/* 뢮 ᮮ饭  訡  ࠭
    襭 ࠡ ணࠬ */
#define errmessage(txt) {sprintf(res,"%s",txt); return 1;}

int c_urav(char *in, char *res)
{	char buf[100];               /*    */
	char eq[256];                /*   ࠢ */
	struct composition comp[20]; /*  ᮥ */
	char elem[60] = {0};	     /* ᨢ  ࠭  .*/
				     /* 2     */
	char ce[3]={0};	             /*  ⥪饣 娬.  */
	double a[20][20] = {0};      /*   ࠭ ⥬ -*/
	double x[20];                /*   ࠭ . */
	int ncomp; /* (᫮ ᮥ  ࠢ) - 1 */
	int nelem; /* (᫮ ⮢  ᮥ) - 1 */

	struct brackets br[4] =      /* ᨢ  ࠭ ࠬ஢ ᪮ */
	{'[',']',-1,-1,1,
	 '(',')',-1,-1,1,
	 '*',13,-1,-1,1,
	 '{','}',-1,-1,1};

	double ta, tb;          /* ६ ६ */
	char *cptr;
	int i, j, k;            /* 稪 横 */
	unsigned char c, c1;    /*  ६ */
	double ii;              /*  । ⮬ */
	int n;                  /*    . */

	/***** I.    *****/
	res[0] = 0;
	for (i = 0, j = 0; i < strlen(in); i++)
		if (in[i] != ' ') eq[j++] = in[i];
	eq[j] = 0;	

	/***** II.     ***/
	i = -1; /*   ࠢ */
	j = 0;  /*   㫥 ᮥ */
	k = 0;  /* ᫮  ࠢ⢠ */
	n = 1;  /*  ࠡ
		  0 몫 ࠧ
		  1  ࠧ */
	ncomp = 0; /*  㥬 ᮥ */
	do
	{
		c = eq[++i];
		if (c == '{') n = 0;
		if (c == '}') n = 1;
		if ( (c == '+' && n) || c == '=')
		{
			if (c == '=') k++;
			comp[ncomp++].name[j] = 0;
			j = 0;
		}
		else
			comp[ncomp].name[j++] = c;
	}
	while (c);
	if (!n) errmessage(ERR_SYNT);

	/***** III.    *****/
	if (ncomp > 19) errmessage(ERR_MANYCOMP);
	if (k != 1) /*   1  '=' */
		errmessage(ERR_EQU);

	for (i = 0; i <= ncomp; i++)
	{
		c = comp[i].name[0];
		if (c == 0) /*    2 '+'  */
			errmessage(ERR_PLUS);
		if ( !(c >= 'A' && c <= 'Z') && c != 'e' && c != '(' && c != ')' && c != '[' && c != ']')
			errmessage(ERR_SYNT);
	}

	/***** IV.    -   ***/
	nelem = -1;
	for (i = 0; i <= ncomp; i++)
	{
		/***    ᮤঠ ᪮ ***/
		for (j = 0; j <= 3; j++) /*  ᨢ  . ᪮ */
		{	br[j].open_pos = -1;
			br[j].close_pos = -1;}

		for (j = 0; j <= strlen(comp[i].name); j++) /*  ᪮ */
		{
			c = comp[i].name[j];
			for (k = 0; k <= 3; k++)
			{
				if (c == br[k].open_sign) /* 뢠騥 ᪮ */
				{ if (br[k].open_pos != -1) errmessage(ERR_MANYBR);
				  br[k].open_pos = j;
				  if (k == 2) /* 񧤮窠 */
				  {	  br[2].close_pos = strlen(comp[i].name) + 1;
					  br[2].index = strtod(&comp[i].name[j + 1],&cptr);
					  if (br[k].index == 0) br[k].index = 1;}
				}

				if (c == br[k].close_sign) /* 뢠騥 ᪮ */
				{       if (br[k].close_pos != -1) errmessage(ERR_MANYBR);
					br[k].close_pos = j;
					br[k].index = strtod(&comp[i].name[j + 1],&cptr);
					if (br[k].index == 0) br[k].index = 1;}
			}
		}
		/* ஢ઠ ᨭ⠪ ᪮ */
		for (k = 0; k <= 3; k++)
			if ((br[k].open_pos == -1 && br[k].close_pos != -1)||(br[k].open_pos > br[k].close_pos)) errmessage(ERR_SYNTBR);

		/* 뤥 ᪮ 鸞 */
		if (br[3].open_pos != -1 && br[3].close_pos != -1)
		{	/* 뤥 ᮫⭮ 祭 */
			comp[i].charge = strtol(&comp[i].name[br[3].open_pos + 1], &cptr, 10);
			/* ࠡ⪠  */
			c = comp[i].name[br[3].close_pos - 1];
			if ((c == '-' || c == '+') && comp[i].charge == 0) comp[i].charge = 1;
			if (c == '-') comp[i].charge = -comp[i].charge;
		}
		else comp[i].charge = 0;

		/*   ਧ ஭ */
		if (comp[i].name[0] == 'e')
		{	comp[i].charge = -1;
			continue;}

		/* ⠪᪨ ࠧ  ⠬ */
		for (j = 0; j <= strlen(comp[i].name); j++)
		{
			/*  ᨬ  */
			c = comp[i].name[j];
			if (c < 'A' || c > 'Z') continue;
			ce[0] = c;

			/* ⪠ 㦨 ன ᨬ  */
			c1 = comp[i].name[j + 1];
			ce[1] = (c1 < 'a' || c1 > 'z') ? 32 : c1;

			/* 뤥  */
			if (ce[1] == 32)
				ii = strtod(&comp[i].name[j + 1], &cptr);
			else
				ii = strtod(&comp[i].name[j + 2], &cptr);

			if (ii == 0) ii = 1; /*  砥 ⢨ ᫠ */
					     /*  - 1*/

			/* ᮢ   ᪮ */
			for (k = 0; k <= 2; k++)
				if (j > br[k].open_pos && j < br[k].close_pos) ii *= br[k].index;

			/* ᥭ    ப */
			if (strstr(elem, ce) == NULL)
			{	strcat(elem, ce);
				nelem++; }

			/* ᫥    ᥭ    */
			n = (strstr(elem, ce) - &elem[0]) / 2;
			a[n][i] += ii;
		}
	}
	if (nelem > 19) errmessage(ERR_MANYELEM); /*  ᫨誮   ⮢? */

	/***** V.         *****/
	for (i = 0; i <= nelem; i++)
	{
		n = 0;
		for (j = 0; j <= ncomp; j++) if (a[i][j]) n++;
		if (n < 2)
		{
			sprintf(res, ERR_WRONGEL, elem[i * 2], elem[i * 2 + 1]);
			return 1;
		}
	}

	/***** VI.    
		          ***/
	n = 0;
	for (i = 0; i <= ncomp; i++)
	{
		a[nelem + 1][i] = comp[i].charge;
		if (comp[i].charge) n++;
	}
	if (n == 1) errmessage (ERR_CHARGE);/* ᫨ ⮫쪮 1 .  */
	if (n) nelem++;                     /* ७ ࠭  */

	/***** VII.    *****/
	i = gauss(a, ncomp, nelem + 1, x);
	if (i == GAUSS_NOSOL) errmessage(ERR_NOSOL);
	if (i == GAUSS_MANYSOL) errmessage(ERR_MANYSOL);
	x[ncomp] = 1;

	/***** VIII.      *****/
	for (i = 1; i <= 1000; i++)
	{
		/* ஢ઠ  i  ਣ */
		k = 1;
		for (j = 0; j <= ncomp; j++)
		{
			ta = x[j] * (double)i;
			tb = rou(ta) - ta;
			if (cmpzero(tb)) {k = 0; break;}
		}

		/* ⢥  */
		if (k == 1)
		{
			for (j = 0; j <= ncomp; j++) x[j] *= (double)i;
			break;
		}
	}

   /***** IX.   *****/
   /*   . 樥⠬ - த
       ⥫묨 - 室 */
   if (x[0] < 0) k = -1; else k = 1;
   for (i = 0; i <= ncomp; i++) x[i] *= k;

   /* ) 뢮 室  */
   j = 0; /* ᫨ 0 - -  砫 */
   for (i = 0; i <= ncomp; i++)
   {
    /* 뢮 ᮥ i  樥⮬ */
    if (x[i] <= 0) continue;
    if (i > 0 && j) PRINT("%s", " + "); /* 뢮  - ࠧ⥫ */
    j++;
    if (cmpzero(x[i] - 1.0)) PRINT("%.0f ",x[i]);
    PRINT("%s",comp[i].name);
   }
   PRINT("%s", " = "); /* 뢮  ࠢ⢠ */

   /* ) 뢮 த⮢ */
   j = 0; /* ᫨ 0 - -  砫 */
   for (i = 0; i <= ncomp; i++)
   {
    /* 뢮 ᮥ i  樥⮬ */
    if (x[i] >= 0) continue;
    if (i > 0 && j) LPRINT(" + "); /* 뢮  - ࠧ⥫ */
    j++;
    if (cmpzero(-x[i] - 1.0)) PRINT("%.0f ",-x[i]);
    PRINT("%s",comp[i].name);
   }
   return 0;
}

/**********   **********/
/* 㭪 㣫 ᫮  ⥬᪨ :
   3.6 = 4  -3.6 = - 4   3.1 = 3   -3.1 = 3 */
double rou(double x)
{
 double c, d;
 d = modf(x, &c);
 if (fabs(d) < 0.5) return c;
 if (x < 0) return c - 1.0;
 if (x > 0) return c + 1.0;
}

/* ࠢ ᫠  㫥  筮 ACCURACY */
/* 0 - ᫨ 0
   1 - ᫨  0 */
char cmpzero(double x)
{
	return (fabs(x) > ACCURACY);
}
